<template>
    <div class="max-w-[900px] m-auto h-[650px] bg-[#F3F3F3] rounded-[24px] shadow-form-shadow p-8 flex flex-col justify-between">
        <div class="grid w-full">
            <div class="flex justify-end"><span @click="switchLanguage" :class="locale === 'en' && 'text-red-500'" id="en" class="mr-[20px] cursor-pointer">EN</span><span class="cursor-pointer" :class="locale === 'ru' && 'text-red-500'" @click="switchLanguage" id="ru">RU</span></div>
            <div class="grid gap-[32px]">
                <div class="w-full">
                    <h3 class="pb-[5px] text-form-label">{{$t('username')}} <span class="text-red-500">*</span></h3>
                    <MyInput name="name" v-model="inputName" :placeholder="$t('placeholders.username')" />
                    <span class="text-red-500" v-show="errors['form.inputName']">{{ $t('errors.nameAtLeast') }}</span>
                </div>
                <div class="w-full">
                    <h3 class="pb-[5px] text-form-label">{{$t('phone')}} <span class="text-red-500">*</span></h3>
                    <MyInput @masked="(mask) => masked = mask" mask v-model="inputFullTel" placeholder="+380 (XXX) XXX XXXX" />
                    <span class="text-red-500" v-show="errors['form.inputFullTel']">{{ $t('errors.phoneIsRequired') }}</span>
                    <span class="text-red-500" v-show="telephoneError">{{ $t('errors.correctPhone')}}</span>
                </div>
                <div class="w-full">
                    <div class="grid grid-cols-2 gap-[32px] justify-center">
                        <div class="w-full">
                            <h3 class="pb-[5px] text-form-label">{{$t('password')}} <span class="text-red-500">*</span></h3>
                            <MyInput v-model="inputPassword" :placeholder="$t('placeholders.password')" />
                            <span class="text-red-500" v-show="errors['form.inputPassword']">{{ $t('errors.password') }}</span>
                            <span class="text-red-500" v-show="passwordsMatchError">{{ $t('errors.passwordNotMatch') }}</span>
                        </div>
                        <div class="w-full">
                            <h3 class="pb-[5px] text-form-label">{{$t('сonfirmPassword')}} <span class="text-red-500">*</span></h3>
                            <MyInput v-model="inputConfirmPassword" :placeholder="$t('placeholders.password')" />
                            <span class="text-red-500" v-show="errors['form.inputConfirmPassword']">{{ $t('errors.password') }}</span>
                        </div>
                    </div>
                </div>
                <div class="w-full">
                    <div class="max-w-[460px] m-auto pb-[30px]">
                        <h3 class="pb-[5px] text-form-label">{{$t('date')}} <span class="text-red-500">*</span></h3>
                        <MyDate @change="toCalculateAge" v-model="inputDate" placeholder="06-05-2001" />
                        <span class="text-red-500">{{ errors['form.inputDate']}}</span>
                        <span class="text-red-500" v-show="ageError">{{$t('errors.age')}}</span>
                    </div>
                </div>
            </div>
        </div>
        <div class="text-center">
            <button @click="toSendForm" :disabled="!inputName" class="bg-[#0048D9] rounded-[6px] py-[12px] px-[16px] font-semibold text-white text-center disabled:opacity-25">{{$t('buttons.submit')}}</button>
        </div>
    </div>
</template>

<script setup>
import MyInput from '../components/MyInput.vue'
import MyDate from '../components/MyDate.vue'
import { computed, ref } from 'vue'

import { useField, useForm } from 'vee-validate'

import * as yup from 'yup'

import { useI18n } from 'vue-i18n'
const { t, locale } = useI18n()
const { handleSubmit, resetForm, errors } = useForm({
  validationSchema: yup.object({
    form: yup.object({
      inputName: yup.string().required().min(2, t('errors.nameAtLeast')).label('Name'),
      inputFullTel: yup.string().required(t('errors.phoneIsRequired')).label('Phone'),
      inputPassword: yup.string().required().min(6, t('errors.password')).label('Password'),
      inputConfirmPassword: yup.string().required().min(6, t('errors.password')).label('ConfirmPassword'),
      inputDate: yup.string().required(t('errors.date')).label('Date')
    })
  })
})

const { value: inputName } = useField('form.inputName')
const { value: inputFullTel } = useField('form.inputFullTel')
const { value: inputPassword } = useField('form.inputPassword')
const { value: inputConfirmPassword } = useField('form.inputConfirmPassword')
const { value: inputDate } = useField('form.inputDate')

const passwordsMatchError = ref(false)
const ageError = ref(false)
const telephoneError = ref(false)
const masked = ref()

const toSendForm = handleSubmit((values) => {
  beforeSendHandling(values)
})

const beforeSendHandling = (values) => {
  if (values.form.inputFullTel.slice(0, -1).split('').includes('_')) {
    telephoneError.value = true
  } else {
    telephoneError.value = false
  }

  if (values.form.inputPassword !== values.form.inputConfirmPassword) {
    passwordsMatchError.value = true
  } else {
    passwordsMatchError.value = false
  }

  if (toCalculateAge.value < 18) {
    ageError.value = true
  } else {
    ageError.value = false
  }

  if (!passwordsMatchError.value && !ageError.value && !telephoneError.value) {
    values.form.inputTelNumber = masked.value.unmaskedValue
    values.form.inputFullTel = values.form.inputFullTel.slice(0, -1)
    console.log(values.form)
    resetForm()
    inputFullTel.value = '+38(___)___-____'
    console.log('Data was sent')
  }
}

const toCalculateAge = computed(() => {
  const now = new Date()
  const today = new Date(now.getFullYear(), now.getMonth(), now.getDate())
  const userBirthDay = new Date(inputDate.value)
  const birthThisYear = new Date(today.getFullYear(), userBirthDay.getMonth(), userBirthDay.getDate())
  let age

  age = today.getFullYear() - userBirthDay.getFullYear()
  // Если ДР в этом году ещё предстоит, то вычитаем из age один год
  if (today < birthThisYear) {
    age = age - 1
  }
  return age
})

const switchLanguage = (event) => {
  locale.value = event.target.id
  localStorage.setItem('lang', locale.value)
}

</script>
